/*
	ConsoleLib Copyright 1994-2000 Ogasawara Hiroyuki

	Ƃ X68000 Ko-Window p KX_Term20(vt100݊^[~i\tg)
	̃[`ƂĊĴ Zaurus pɏĆB
*/

#include	<zheaders.h>
#include	"console.h"

FConsole	_Cons;

/*--------------------------------------------------------------------------*/

static struct {
	unsigned char	x, y;
} _sizelist[]= {
	{	2,	4,	},	// 0 QP16 4dot
	{	3,	6,	},	// 1 QP24 6dot
	{	4,	8,	},	// 2 QP32 8dot
	{	4,	10,	},	// 3 QP40 10dot
	{	6,	12,	},	// 4 QP48 12dot
	{	7,	14,	},	// 5 QP56 14dot
	{	8,	16,	},	// 6 QP64 16dot
	{	9,	18,	},	// 7 QP72 18dot
	{	10,	20,	},	// 8 QP80 20dot
	{	12,	24,	},	// 9 QP96 24dot
	{	16,	32,	},	// a QP128 32dot
	{	18,	36,	},	// b QP144 36dot
	{	20,	40,	},	// c QP160 40dot
	{	24,	48,	},	// d QP192 48dot
};


void
ConsoleSetScreen( FConsole *cp, int width, int height, int font,
					int xoffset, int yoffset )
{
	int	fontx= _sizelist[font].x;
	int	fonty= _sizelist[font].y;
	ConsoleDrawCursor( cp, FALSE );
	cp->Begin.x= xoffset*4;
	cp->Begin.y= yoffset*4;
	cp->End.x= width*fontx*4-1+cp->Begin.x;
	cp->End.y= height*fonty*4-1+cp->Begin.y;
	cp->StepX= fontx*4;
	cp->StepY= fonty*4;
	cp->Width= width;
	cp->Height= height;
	cp->Font= font<<4;
	ConsoleDrawCursor( cp, TRUE );
}

void
ConsoleInit( FConsole *cp, WINDOWHD wp )
{
#if 0
	cp->Begin.x= 0;
	cp->Begin.y= CONSOLE_OFFSET*4;
	cp->End.x= CONSOLE_WIDTH*CONSOLE_DEFFONTX*4-1;
	cp->End.y= CONSOLE_HEIGHT*CONSOLE_DEFFONTY*4-1+cp->Begin.y;
	cp->StepX= CONSOLE_DEFFONTX*4;
	cp->StepY= CONSOLE_DEFFONTY*4;
	cp->Width= CONSOLE_WIDTH;
	cp->Height= CONSOLE_HEIGHT;
#endif
	cp->wp= wp;
	cp->Fg.rgb.red= 0;
	cp->Fg.rgb.green= 0;
	cp->Fg.rgb.blue= 0;
	cp->Fg.rgb.info= 0;
	cp->Bg.rgb.red= 255;
	cp->Bg.rgb.green= 255;
	cp->Bg.rgb.blue= 255;
	cp->Bg.rgb.info= 0;
	cp->DrawFlag= 0;
	cp->Font= CONSOLE_FONT;
	//ConsoleCls( cp );
}

void
ConsoleCls( FConsole *cp )
{
	ConsoleDrawCursor( cp, FALSE );
	cp->CursorX= 0;
	cp->CursorY= 0;
	cp->Pos.x= cp->Begin.x;
	cp->Pos.y= cp->Begin.y;
	cp->Ptr= cp->LineBuf;
	memset( cp->ScreenBuf, 0, cp->Height*(cp->Width+2) );
	AreaClear( cp->wp, &cp->Begin, &cp->End, &cp->Bg, FBSET, NULL );
	ConsoleDrawCursor( cp, TRUE );
}

void
ConsoleDrawCursor( FConsole *cp, int flag )
{
	int	draw= FALSE;
	if( flag ){
		if( ++cp->DrawFlag == 1 )
			draw= TRUE;
	}else{
		if( --cp->DrawFlag == 0 )
			draw= TRUE;
	}
	if( draw ){
#if 0 // FullCursor
		POINT	end;
		end.x= cp->Pos.x+cp->StepX-1*4;
		end.y= cp->Pos.y+cp->StepY-1*4;
		cp->DrawFlag= flag;
		BoxPaint( cp->wp, &cp->Pos, &end, &cp->Fg, &cp->Bg,
							FBEX, P_BLACK, NULL );
#else // HalfCursor
		POINT	end;
		POINT	start;
		start.x= cp->Pos.x;
		start.y= cp->Pos.y + (cp->StepY>>1);
		end.x= cp->Pos.x+cp->StepX-1*4;
		end.y= cp->Pos.y+cp->StepY-1*4;
		cp->DrawFlag= flag;
		BoxPaint( cp->wp, &start, &end, &cp->Fg, &cp->Bg,
							FBEX, P_BLACK, NULL );
#endif
	}
}


void
ConsoleScroll( FConsole *cp )
{
	ConsoleDrawCursor( cp, FALSE );
	ScrollUp( cp->wp, &cp->Begin, &cp->End,
				&cp->Bg, FSET, true, cp->StepY );
	memcpy( &cp->ScreenBuf[0], &cp->ScreenBuf[1],
				(cp->Width+2)*(cp->Height-1) );
	memset( &cp->ScreenBuf[cp->Height-1], ' ', cp->Width );
	cp->ScreenBuf[cp->Height-1][cp->Width]= '\0';
	ConsoleDrawCursor( cp, TRUE );
}


void
ConsoleFlushPosition( FConsole *cp )
{
	ConsoleDrawCursor( cp, FALSE );
	cp->Pos.x= cp->CursorX*cp->StepX + cp->Begin.x;
	cp->Pos.y= cp->CursorY*cp->StepY + cp->Begin.y;
	ConsoleDrawCursor( cp, TRUE );
}


void
ConsoleFlush( FConsole *cp )
{
	if( cp->Ptr != cp->LineBuf ){
		ConsoleDrawCursor( cp, FALSE );
		*cp->Ptr= '\0';
		DrawStr( cp->wp, &cp->Pos, &cp->Fg, &cp->Bg,
			cp->Font, /*FBSET|CONSOLE_FONT*/
			cp->LineBuf, 0, NULL, DS_NORMAL );
		cp->Ptr= cp->LineBuf;
		ConsoleFlushPosition( cp );
		ConsoleDrawCursor( cp, TRUE );
	}
}


void
ConsoleCR( FConsole *cp )
{
	ConsoleDrawCursor( cp, FALSE );
	ConsoleFlush( cp );
	cp->CursorX= 0;
	ConsoleFlushPosition( cp );
	ConsoleDrawCursor( cp, TRUE );
}

void
ConsoleNextLine( FConsole *cp )
{
	ConsoleDrawCursor( cp, FALSE );
	ConsoleFlush( cp );
	if( ++cp->CursorY >= cp->Height ){
		ConsoleScroll( cp );
		cp->CursorY= cp->Height-1;
	}
	ConsoleFlushPosition( cp );
	ConsoleDrawCursor( cp, TRUE );
}

void
ConsoleCRLF( FConsole *cp )
{
	ConsoleDrawCursor( cp, FALSE );
	ConsoleFlush( cp );
	cp->CursorX= 0;
	if( ++cp->CursorY >= cp->Height ){
		ConsoleScroll( cp );
		cp->CursorY= cp->Height-1;
	}
	ConsoleFlushPosition( cp );
	ConsoleDrawCursor( cp, TRUE );
}

void
ConsoleLocation( FConsole *cp, int x, int y )
{
	ConsoleDrawCursor( cp, FALSE );
	ConsoleFlush( cp );
	cp->CursorX= x;
	cp->CursorY= y;
	ConsoleFlushPosition( cp );
	ConsoleDrawCursor( cp, TRUE );
}


void
ConsoleBS( FConsole *cp )
{
	ConsoleDrawCursor( cp, FALSE );
	ConsoleFlush( cp );
	if( cp->CursorX ){
		--cp->CursorX;
	}else{
		cp->CursorX= cp->Width-1;
		if( cp->CursorY ){
			--cp->CursorY;
		}
	}
	ConsoleFlushPosition( cp );
	ConsoleDrawCursor( cp, TRUE );
}

void
ConsoleTAB( FConsole *cp )
{
	int	len= 8-(cp->CursorX & 7);
	for(; len-- ; ConsoleChar( cp, ' ' ) );
}


static void
_ConsoleChar( FConsole *cp, int ch )
{
	int	kanji= 0;
	if( cp->EscFlag ){
		static int	num, num2;
		if( cp->NumFlag ){
			switch( ch ){
			case ';':
				num2= num;
				num = 0;
				break;
			case 'K':
				if( num == 0 ){
#if 0
					DrawSetLine( dbuf, CPX, CPY,
						SCREENSIZEX*font_x-1, CPNY,
						BackColor, OptionFill );
					WindowDraw( Bwp, dbuf, 1 );
					memset2( SCRLINE(cury)+curx, ' ', SCREENSIZEX-curx );
#endif
				}else if( num == 1 ){
#if 0
					DrawSetLine( dbuf, 0, CPY, CPX-1, CPNY,
						BackColor, OptionFill );
					WindowDraw( Bwp, dbuf, 1 );
					memset2( SCRLINE(cury), ' ', curx );
#endif
				}else{
				clrline:
#if 0
					DrawSetLine( dbuf, 0, CPY,
						SCREENSIZEX*font_x-1, CPNY,
						BackColor, OptionFill );
					WindowDraw( Bwp, dbuf, 1 );
					memset2( SCRLINE(cury), ' ', SCREENSIZEX );
#endif
				}
				cp->EscFlag= FALSE;
				break;
			case 'J':
				if( num == 2 ){
					ConsoleCls( cp );
				}else if( num == 0 ){
#if 0
					short	i;
				clrscr0:
					DrawSetLine( dbuf, CPX, CPY,
						SCREENSIZEX*font_x-1, CPNY,
						BackColor, OptionFill );
					DrawSetLine( dbuf+1, 0, (cury+1)*font_y,
						SCREENSIZEX*font_x-1,
						SCREENSIZEY*font_y-1,
						BackColor, OptionFill );
					WindowDraw( Bwp, dbuf, 2 );
					memset2( SCRLINE(cury)+curx, ' ', SCREENSIZEX-curx );
					for( i= cury+1 ; i< SCREENSIZEY ; i++ )
						memset2( SCRLINE(i), ' ', SCREENSIZEX );
#endif
				}else if( num == 1 ){
#if 0
					short	i;
					DrawSetLine( dbuf, 0, CPY, CPX-1, CPNY,
								BackColor, OptionFill );
					DrawSetLine( dbuf+1, 0, 0, SCREENSIZEX*font_x-1,
							CPNY, BackColor, OptionFill );
					WindowDraw( Bwp, dbuf, 2 );
					memset2( SCRLINE(cury), ' ', curx );
					for( i= 0 ; i< cury ; i++ )
						memset2( SCRLINE(i), ' ', SCREENSIZEX );
#endif
				}
				cp->EscFlag= FALSE;
				break;
			case '@': {
#if 0
				unsigned char	*a,
						*b= SCRLINE(cury)+SCREENSIZEX;
				short		i;
				if( num < 1 )
					num= 1;
				if( (i= SCREENSIZEX-curx-num)< 0 )
					i= 0, num= SCREENSIZEX-curx;
				for( a= b-num ; i-- ; *--b= *--a );
				for( i= num ; i-- ; *--b= ' ' );
				DrawSetSymbol( dbuf, curx*font_x, cury*font_y,
					(void*)&SCR(curx,cury), attr, font_y );
				WindowDraw( Bwp, dbuf, 1 );
#endif
				cp->EscFlag= FALSE;
				}
				break;
			case 'P': {
#if 0
				unsigned char	*a,
						*b= SCRLINE(cury)+curx;
				short		i;
				if( num < 1 )
					num= 1;
				if( (i= SCREENSIZEX-curx-num)< 0 )
					i= 0, num= SCREENSIZEX-curx;
				for( a= b+num ; i-- ; *b++= *a++ );
				for( i= num ; i-- ; *b++= ' ' );
				DrawSetSymbol( dbuf, curx*font_x, cury*font_y,
					(void*)&SCR(curx,cury), attr, font_y );
				WindowDraw( Bwp, dbuf, 1 );
#endif
				cp->EscFlag= FALSE;
				}
				break;
			case 'X': {
#if 0
				if( num < 1 )
					num= 1;
				if( curx+num >= SCREENSIZEX )
					num= SCREENSIZEX-curx;
				memset2( SCRLINE(cury)+curx, ' ', num );
				DrawSetLine( dbuf, curx*font_x, cury*font_y,
				(curx+num)*font_x-1, (cury+1)*font_y+-1, BackColor, OptionFill );
				WindowDraw( Bwp, dbuf, 1 );
#endif
				cp->EscFlag= FALSE;
				}
				break;
			case 'H': /* --- Direct cursor addressing */
			case 'f': /* --- Direct cursor addressing */
				{
					int	curx= num <=1 ? 0 : num-1;
					int	cury;
					if( curx >= cp->Width )
						curx= cp->Width-1;
					cury= num2<=1 ? 0 : num2-1;
					if( cury >= cp->Height )
						cury= cp->Height-1;
					ConsoleLocation( cp, curx, cury );
				}
				cp->EscFlag= FALSE;
				break;
			case 'A': /* --- Cursor up */
				{
					int	cury= cp->CursorY;
					cury-= num<=1 ? 1 : num;
					if( cury < 0 )
						cury= 0;
					ConsoleLocation( cp,
							cp->CursorX, cury );
				}
				cp->EscFlag= FALSE;
				break;
			case 'B': /* --- Cursor down */
				{
					int	cury= cp->CursorY;
					cury+= num<=1 ? 1 : num;
					if( cury >= cp->Height )
						cury= cp->Height-1;
					ConsoleLocation( cp,
							cp->CursorX, cury );
				}
				cp->EscFlag= FALSE;
				break;
			case 'C': /* --- Cursor forward */
				{
					int	curx= cp->CursorX;
					curx+= num<=1 ? 1 : num;
					if( curx >= cp->Width )
						curx= cp->Width-1;
					ConsoleLocation( cp, curx,
								cp->CursorY );
				}
				cp->EscFlag= FALSE;
				break;
			case 'D': /* --- Cursor backward */
				{
					int	curx= cp->CursorX;
					curx-= num<=1 ? 1 : num;
					if( curx < 0 )
						curx= 0;
					ConsoleLocation( cp, curx,
								cp->CursorY );
				}
				cp->EscFlag= FALSE;
				break;
			case 'M': /* --- Delete Line */
			delline:
#if 0
				term_delete( num<=1 ? 1 : num );
				curx= 0;
#endif
				cp->EscFlag= FALSE;
				break;
			case 'L': /* --- Insert Line */
#if 0
				term_insert( num<=1 ? 1 : num );
				curx= 0;
#endif
				cp->EscFlag= FALSE;
				break;
			case 's': /* --- Svae cursor position */
		save_cursor_pos:
#if 0
				bcurx= curx;
				bcury= cury;
				battr= attr;
#endif
				cp->EscFlag= FALSE;
				break;
			case 'u': /* --- Set cursor position */
		set_cursor_pos:
#if 0
				curx= bcurx;
				cury= bcury;
				attr= battr;
#endif
				cp->EscFlag= FALSE;
				break;
			case 'n': /* --- Cursor position report */
#if 0
				if( num == 6 ){
					RsOutChar( 0x1b );
					RsOutChar( '[' );
					RsOutChar( (cury+1)/10+'0' );
					RsOutChar( (cury+1)%10+'0' );
					RsOutChar( ';' );
					RsOutChar( (curx+1)/10+'0' );
					RsOutChar( (curx+1)%10+'0' );
					RsOutChar( 'R' );
				}else if( num == 5 )
					RsOutStr( "\x1b[0n" );
#endif
				cp->EscFlag= FALSE;
				break;
			case 'h':
				if( num == 5 ){
					ConsoleDrawCursor( cp, FALSE );
				}
#ifdef	SCREENSAVE
				else if( num == 47 )
					term_screen_save();
#endif
				cp->EscFlag= FALSE;
				break;
			case 'l':
				if( num == 5 ){
					ConsoleDrawCursor( cp, TRUE );
				}
#ifdef	SCREENSAVE
				else if( num == 47 )
					term_screen_load();
#endif
				cp->EscFlag= FALSE;
				break;
			case 'r':
#if 0
				if( num2 == 0 && num == 0 ){
					scr_s= 0;
					scr_e= SCREENSIZEY-1;
				}else{
					scr_s= num2 ? num2-1 : num2 ;
					scr_e= num  ? num-1  : num ;
				}
#endif
				cp->EscFlag= FALSE;
				break;
			case 'm': /* --- Character attribute */
#if 0
				if( num == 7 )
					attr ^= AttrReverse;
				else if( num == 1 || num == 5 )
					attr ^= AttrHighLight;
				else if( num == 3 )
					attr ^= AttrMesh;
				else if( num == 0 )
					attr = DefaultColor;
				else if( num >= 30 && num < 48 )
					attr = attrtable[num-30];
				BackColor= attr & AttrReverse ? attr&3:0;
				Cdbuf.code= (attr&3)|OptionXor;
#endif
				cp->EscFlag= FALSE;
				break;
#if 0
			case 'E': /* --- Enter status line */
			case 'F': /* --- Exit status line */
			case 'T': /* --- Status position */
			case 'Z': /* --- Exec Macro */
				cp->EscFlag= FALSE;
				keymacro_exec( num, 'P' );
				break;
#endif
			case '#': /* --- Set Screen Mode */
				if( cp->Height < 24 ){
					switch( num ){
					case 0:
					default:
						ConsoleCls( cp );
					ConsoleSetScreen( cp, 80, 15, 3, 0,0);
						break;
					case 1:
						ConsoleCls( cp );
					ConsoleSetScreen( cp, 53, 12, 4, 0,0);
						break;
					}
				}else{
					switch( num ){
					case 0:
					default:
						ConsoleCls( cp );
					ConsoleSetScreen( cp, 80, 28, 3,80,8);
						break;
					case 1:
						ConsoleCls( cp );
					ConsoleSetScreen( cp, 80, 24, 4,80,8);
						break;
					}
				}
				ConsoleCls( cp );
				cp->EscFlag= FALSE;
				break;
			default:
				if( ch >= '0' && ch<= '9' ){
					num*= 10;
					num+= ch-'0';
				}else if( ch >= 'A' && ch<= 'z' ){
					cp->EscFlag= FALSE;
				}
			}
		}else{
			switch( ch ){
			case '[':
				num=
				num2= 0;
				cp->NumFlag= TRUE;
				break;
			case '*': /* --- Clear screen */
				ConsoleCls( cp );
				cp->EscFlag= FALSE;
				break;
#if 0
			case '=': /* --- Direct cursor addressing */
				if( vt100 ){
					escflag= FALSE;
					break;
				}
				equflag= TRUE;
				num=
				num2= -1;
				escflag= FALSE;
				break;
#endif
			case 'D': /* --- Index */
				cp->EscFlag= FALSE;
				ConsoleNextLine( cp );
				break;
			case 'E': /* --- Next line */
				cp->EscFlag= FALSE;
				ConsoleCRLF( cp );
				break;
#if 0
			case 'M': /* --- Reverse index */
				if( cury > scr_s )
					cury--;
				else
					term_bscroll();
				escflag= FALSE;
				break;
#endif
#if 0
			case 'R':
				num= 0;
				goto	delline;
			case 'T':
				goto	clrline;
			case 'Y':
				goto	clrscr0;
			case '7': /* --- save cursor position */
				goto	save_cursor_pos;
			case '8': /* --- set cursor position */
				goto	set_cursor_pos;
#endif
			case '<': /* --- dummy code */
			case '>': /* --- dummy code */
				cp->EscFlag= FALSE;
				break;
#if 0
			case 'c': /* --- Init All Clear */
				term_init();
				break;
#endif
			}
		}
	}else if( ch >= 0 && ch < ' ' ){
		switch( ch ){
		case '\n': // 0x0a
			ConsoleNextLine( cp );
			break;
		case '\r': // 0x0d
			ConsoleCR( cp );
			break;
		case '\b': // 0x08
			ConsoleBS( cp );
			break;
		case '\t': // 0x09
			ConsoleTAB( cp );
			break;
		case 0x0c:
			if( cp->CursorX+1 < cp->Width ){
				ConsoleLocation( cp,
					cp->CursorX+1, cp->CursorY );
			}else
				ConsoleLocation( cp, 0, cp->CursorY );
			break;
		case 0x0b:
			if( cp->CursorY ){
				ConsoleLocation( cp,
					cp->CursorX, cp->CursorY-1 );
			}
			break;
		case 0x1a:
			//ConsoleCls( cp );
			break;
		case 0x1e:
			ConsoleLocation( cp, 0, 0 );
			break;
		case 0x1b:
			cp->EscFlag= TRUE;
			cp->NumFlag= FALSE;
			break;
		}
	}else{
		if( kanji == 1 ){
			kanji= 2;
		}else if( (ch >= 0x80 && ch < 0xa0) || ch >= 0xe0 ){
			kanji= 1;
		}else{
			kanji= 0;
		}
		*cp->Ptr++= ch;
		if( ++cp->CursorX >= cp->Width ){
			int	save;
			if( kanji == 1 ){
				save= *--cp->Ptr;
			}
			ConsoleCRLF( cp );
			if( kanji == 1 ){
				*cp->Ptr++= save;
				cp->ScreenBuf[cp->CursorY][cp->CursorX]= save;
				cp->CursorX++;
			}
		}else{
			cp->ScreenBuf[cp->CursorY][cp->CursorX-1]= ch;
		}
	}
}

void
ConsoleChar( FConsole *cp, int ch )
{
	static unsigned char	Kcache= 0;
	if( Kcache ){
		_ConsoleChar( cp, Kcache );
		Kcache= 0;
	}else if( (ch >= 0x80 && ch < 0xa0) || ch >= 0xe0 ){
		Kcache= ch;
		return;
	}
	_ConsoleChar( cp, ch );
}

void
ConsolePrint( FConsole *cp, char *ptr )
{
	if( *ptr ){
		for(; *ptr ; ConsoleChar( cp, *ptr++ & 0xff ) );
	}
}


void
ConsoleSet( FConsole *cp )
{
	ConsoleDrawCursor( cp, TRUE );
}

void
ConsoleRedraw( FConsole *cp )
{
	int	i;
	POINT	pos;
	pos.x= cp->Begin.x;
	ConsoleDrawCursor( cp, FALSE );
	for( i= 0 ; i< cp->Height ; i++ ){
		pos.y= i*cp->StepY + cp->Begin.y;
		DrawStr( cp->wp,
			&pos,
			&cp->Fg, &cp->Bg,
			cp->Font,
			cp->ScreenBuf[i], 0, NULL, DS_NORMAL );
	}
	ConsoleDrawCursor( cp, TRUE );
}


