//	DebugOutput()	2000/10/01 Ogasawara Hiroyuki

#define __USE_DEBUG_OUTPUT_20010_INIT
#include	"debugcode.h"
#include	"zxconsole.h"

#if __USE_DEBUG_OUTPUT_20010_

#define	__STATIC static

// mstringLib Copyright 2000 Ogasawara Hiroyuki

__STATIC char *
p_strcpy( char *str, char *ptr )
{
	for(; *str++= *ptr++ ;);
	return	ptr-1;
}

__STATIC char *
s_strcpy( char *str, char *ptr )
{
	for(; *str++= *ptr++ ;);
	return	str-1;
}

__STATIC char *
s_itos( char *str, int num )
{
	char	buf[16];
	char	*s= buf+16;
	int	mi= 0;
	*--s= '\0';
	if( num < 0 ){
		mi= 1;
		num= -num;
	}
	do{
		*--s= num%10 +'0';
	}while( num/= 10 );
	if( mi )
		*str++= '-';
	return	s_strcpy( str, s );
}


__STATIC char *
s_itohs( char *str, int num )
{
	char	buf[16];
	char	*s= buf+16;
	int	mi= 0;
	*--s= '\0';
	do{
		unsigned char	ch= num&15;
		*--s= ch > 9 ? ch+('0'+7) : ch + '0';
	}while( num>>= 4 );
	return	s_strcpy( str, s );
}


__STATIC
char *
s_itosf( char *str, int num, int len )
{
	char	*s= str+=len;
	int	mi= 0;

	if( !len )
		return	s_itos( str, num );

	*s= '\0';
	if( num < 0 ){
		mi= 1;
		num= -num;
	}
	do{
		*--s= num%10 +'0';
		len--;
	}while( num/= 10 );
	if( mi ){
		*--s= '-';
		len--;
	}
	for(; len-- > 0 ; *--s= ' ' );
	return	str;
}


__STATIC char *
s_itohsf( char *str, int num, int len )
{
	char	*s= str+=len;
	int	mi= 0;

	if( !len )
		return	s_itohs( str, num );

	*s= '\0';
	do{
		unsigned char	ch= num&15;
		*--s= ch > 9 ? ch+('0'+7) : ch + '0';
		len--;
	}while( num>>= 4 );
	for(; len-- > 0 ; *--s= ' ' );
	return	str;
}


__STATIC char *
s_formatv( char *str, char *ptr, void **args )
{
	for(; *ptr ;){
		if( *ptr == '%' ){
			int	fnum= 0;
			for(;;){
				switch( *++ptr ){
	//------------------------------------------------------------------
	case 's':
		str= s_strcpy( str, (char*)(*args++) );
		goto	_last;
	case 'd':
		str= s_itosf( str, (int)(*args++), fnum );
		goto	_last;
	case 'x':
		str= s_itohsf( str, (int)(*args++), fnum );
		goto	_last;
	default:
		if( *ptr >= '0' && *ptr <= '9' ){
			fnum= fnum*10 + (*ptr&15);
		}
		break;
	//------------------------------------------------------------------
				}
			}
		_last:
			ptr++;
		}else{
			*str++= *ptr++;
		}
	}
	*str= '\0';
	return	str;
}


#if 1
void
__DebugOutputF( char *format, int a, int b, int c, int d, int e, int f )
{
	char	_stringbuf[256];
	char	*argbuf[8];
	argbuf[0]= (char*)a;
	argbuf[1]= (char*)b;
	argbuf[2]= (char*)c;
	argbuf[3]= (char*)d;
	argbuf[4]= (char*)e;
	argbuf[5]= (char*)f;
	s_formatv( _stringbuf, format, (void**)argbuf );
	zxconsole_putstr( _stringbuf );
	zxconsole_putstr( "\r\n" );
}
#else
#include	<stdarg.h>
void
__DebugOutputF( char *format, ... )
{
#if 0
	char	_stringbuf[256];
	extern void	zaucons_putstr( char *buf );
	s_formatv( _stringbuf, format, (void**)(&format+1) );
	zaucons_putstr( _stringbuf );
#else
	char	_stringbuf[256];
	va_list	ap;
	va_start( ap, format );
	s_formatv( _stringbuf, format, &va_arg( ap, void** ) );
	zxconsole_putstr( _stringbuf );
	va_end( ap );
#endif
}
#endif

void
__DebugWrite( char *format )
{
	extern void	zaucons_putstr( char *buf );
	zxconsole_putstr( format );
	zxconsole_putstr( "\r\n" );
}



#endif


