/* ͥɽ */

#include "crystal.h"
#include	"zxconfig.h"

#if 1
#include "proc.h"
#include "name.h"
#else
#include "xtal/proc.h"
#include "xtal/name.h"
#endif
#include "proc_mem.h"


/* #define niko_printf  l_printf */
#if __USE_ZAUCOMM
# define disp_str(s) zaucomm_putstr(s)
#else
# define disp_str(s)
#endif

#if 0
void disp_str(char *s)
{
	char	*p;
	  /**/
	for(p = s; *p != 0; ++p);
	zaucomm_write_wait(s, p-s);
}
#endif


/*
 * common
 */


char *put_str1(char *s, char *str)
{
	while(*str != 0){
		*s++ = *str++;
	}
	return s;
}


char *put_stra(char *s, char **a, int id, int max, int def)
{
	if(id < 0 || id > max){
		id = def;
	}
	return put_str1(s,a[id]);
}


char *put_n10r(char *s, int n, unsigned int width)
{
	int	t, f;
	char	*p;
	  /**/
	f = 0;
	if(n < 0){
		f = '-';
		n = -n;
	}
	p = s + width;
	while(p > s){
		t = n / 10;
		*--p = (n - t * 10) + '0';
		if((n = t) == 0){
			break;
		}
	}
	if(f && p > s){
		*--p = f;
	}
	return p;
}


char *put_n10l(char *s, int n, unsigned int width)
{
	char	*p, *e, b[16];
	  /**/
	e = b + sizeof(b);
	p = put_n10r(b,n,sizeof(b));
	if(e > p + width){
		e = p + width;
	}
	while(p < e){
		*s++ = *p++;
	}
	return s;
}


char *put_n16r(char *s, unsigned int n, unsigned int width)
{
	char	*p;
	  /**/
	p = s + width;
	while(p > s){
		*--p = "0123456789abcdef"[n & 15];
		n >>= 4;
	}
	return p;
}


void put_name(char *s, OBJECT_NAME name)
{
	unsigned long u;
	int	c;
	char	*p;
	  /**/
	u = (unsigned long)name;
	if(u & 0x80000000){
		u &= 0x7fffffff;
		*s = '#';
		put_n10l(s+1,u,4);
	}else{
		for(p = s + 4; p > s;){
			c = u & 255;
			if(c < 32 || c >= 127){
				c = 32;
			}
			*--p = c;
			u = u >> 8;
		}
	}
}


char *put_fnam(char *s, char *str, unsigned int width)
{
	for(;width != 0 && *str != 0; --width){
		*s++ = *str++;
	}
	return s;
}


/*
 * process info
 */


static char *str_proc_stat[9] = {
	"none", "exist", "ready", "active", "sleep", "wait", "zombie", "kersrv", "?"
};


static char *str_proc_waitstat[7] = {
	"none", "queueR", "queueW", "event", "semaph", "sleep", "?",
};


PROC_INFO	proc_tab[256];


void disp_procinfo()
{
	NAME_INFO_LIST	info;
	PROC_INFO	*proc;
	int		no, time, count, i;
	char		*p, *q, l[80];
	  /**/
	time = sys_gettime();
	if(name_list_first(&info) == -1){
		return;
	}
	for(proc = proc_tab;;){
		if(info.info.address->objType == NK_PROC){
			*proc++ = *(PROC_INFO*)info.info.address;
		}
		if(name_list_next(&info) == -1){
			break;
		}
	}
	if((count = proc - proc_tab) == 0){
		return;
	}
/*         1         2         3         4         5         6         7
 0123456789012345678901234567890123456789012345678901234567890123456789012345678
 12345 12345 123456 123456 123456 12345 1234567 123456 123456 12345678 12345678+
*/
	disp_str(
"name  creat type   stat   w.type w.obj timeout prio.  slice  life     s.life\n");
	for(proc = proc_tab; --count >= 0;){
		for(p = l, q = l + sizeof(l); p < q;){
			*p++ = ' ';
		}
		put_name(l+ 0,proc->name);
		put_name(l+ 6,proc->creator);
		if(proc->type == TASK){
			put_str1(l+12,"task");
		}else if(proc->type == THREAD){
			put_str1(l+12,"thread");
		}else if(proc->type == SYSTEM_TASK){
			put_str1(l+12,"s_task");
		}else if(proc->type == SYSTEM_THREAD){
			put_str1(l+12,"s_thre");
		}else{
			put_str1(l+12,"?");
		}
		put_stra(l+19, str_proc_stat, proc->stat, 7, 8);
		put_stra(l+26, str_proc_waitstat, proc->waitstat, 5, 6);
		if((no = proc->waitstat) >= 1 && no <= 4){
			put_name(l+33, proc->waitlist_name);
		}
		if(proc->stat == SLEEP){
			put_n10r(l+39,proc->timeout-time,7);
		}
		put_n10l(l+47,proc->priority_init,6);
		put_n10l(l+54,proc->timeslice,6);
		put_n10l(l+61,proc->life,8);
		put_n10l(l+70,proc->sys_life,8);
		l[78] = '\n';
		l[79] = 0;
		disp_str(l);
		++proc;
	}
}


/*
 * memory list
 */


static char *str_mem_type[8] = {
	"-", "alloc", "stack", "common", "win", "fix", "fixnpg", "file"
};


MEM_INFO	mem_tab[1];


void disp_memlist()
{
	NAME_INFO_LIST	info;
	MEM_INFO	*mem;
	char		*p, *q, l[80];
	  /**/
	if(name_list_first(&info) == -1){
		return;
	}
/*         1         2         3         4         5         6         7
 01234567890123456789012345678901234567890123456789012345678901234567890123456
 12345 12345 123456 12345678 12345678 12345678 12345  1:12345678.123 12345678+
*/
	disp_str(
"name  creat type   vaddr    vsize    sbrkvsiz common filename       fp\n");
	for(mem = mem_tab;;){
		if(info.info.address->objType == NK_MEM){
			*mem = *(MEM_INFO*)info.info.address;
			for(p = l, q = l + sizeof(l); p < q;){
				*p++ = ' ';
			}
			put_name(l+ 0,mem->name);
			put_name(l+ 6,mem->creator);
			put_stra(l+12,str_mem_type,mem->type,7,0);
			put_n16r(l+19,mem->vaddr,8);
			put_n16r(l+28,mem->vsize,8);
			put_n16r(l+37,mem->sbrk_vsize,8);
			put_name(l+46,mem->common);
			put_fnam(l+53,mem->filename,14);
			put_n16r(l+68,(unsigned long)(mem->fp),8);
			l[76] = '\n';
			l[77] = 0;
			disp_str(l);
		}
		if(name_list_next(&info) == -1){
			break;
		}
	}
}


/*
 * name list
 */


static char *str_objtype[11] = {
	"none", "NIL", "proc", "event", "queue", "semaph",
	"memory", "int_ev", "code", "other", "?",
};


void disp_namelist(int col)
{
	NAME_INFO_LIST info;
	//OBJECT_NAME	creator;
	int		i;
	char		*p, *q, l[80];
	static char	*prompt =
		 "name  creat Type   address  : name  creat Type   address\n";
/*                12345 12345 123456 12345678   12345 12345 123456 12345678+
                  0         1         2         3         4         5
                  012345678901234567890123456789012345678901234567890123456789
*/
	  /**/
	if(name_list_first(&info) == -1){
		return;
	}
	if(col < 1 || col > 2){
		col = 2;
	}
	p = prompt;
	if(col == 1){
		p += 30;
	}
	disp_str(p);
	for(p = l;;){
		if(info.info.address->objType != NK_NAME){
			if(p == l){
				for(q = l + sizeof(l); p < q;){
					*p++ = ' ';
				}
				p = l;
			}
			put_name(p+ 0, info.name);
			put_name(p+ 6,(info.info.address != NULL)? ((PROC_INFO*)(info.info.address))->creator:NIL);
			if((i = info.info.address->objType) == 0xff){
				i = 9;
			}
			put_stra(p+12,str_objtype,i,9,10);
			put_n16r(p+19,(unsigned long)(info.info.address),8);
			if(col == 1){
				l[27] = '\n';
				l[28] = 0;
				disp_str(l);
			}else{
				if(p == l){
					p = l + 30;
				}else{
					l[28] = ':';
					l[57] = '\n';
					l[58] = 0;
					disp_str(l);
					p = l;
				}
			}
		}
		if(name_list_next(&info) == -1){
			break;
		}
	}
	if(col != 1 && p != l){
		l[27] = '\n';
		l[28] = 0;
		disp_str(l);
	}
}


void disp_objinfo(OBJECT_NAME name)
{
	NAME_INFO_LIST info;
	//OBJECT_NAME	creator;
	int		i;
	char		*p, *q, *r, l[80];
	  /**/
	if(name_list_first(&info) == -1){
		return;
	}
	disp_str("name  creat Type   address\n");
	for(p = l;;){
		if(info.info.address->objType != NK_NAME && info.name == name){
			if(p == l){
				for(q = l + sizeof(l); p < q;){
					*p++ = ' ';
				}
				p = l;
			}
			put_name(l+ 0, info.name);
			put_name(l+ 6,(info.info.address != NULL)? ((PROC_INFO*)(info.info.address))->creator:NIL);
			if((i = info.info.address->objType) == 0xff){
				i = 9;
			}
			put_stra(l+12,str_objtype,i,9,10);
			put_n16r(l+19,(unsigned long)(info.info.address),8);
			l[27] = '\n';
			l[28] = 0;
			disp_str(l);
		}
		if(name_list_next(&info) == -1){
			break;
		}
	}
}


int proc_memarea(OBJECT_NAME name, int *area)
{
	NAME_INFO_LIST	info;
	PROC_INFO	proc;
	MEM_INFO	*mem0, *mem1;
	int		r;
	  /**/
	area[0] = 
	area[1] = 
	area[2] = 
	area[3] = -1;
	if(name_list_first(&info) == -1){
		return -1; /* cannot get profinfo */
	}
	do{
		if(info.info.address->objType == NK_PROC){
			proc = *(PROC_INFO*)info.info.address;
			if(info.name == name){
				mem0 = proc.data;
				mem1 = proc.stack;
				area[0] = mem0->vaddr;
				area[1] = area[0] + mem0->sbrk_vsize - 1;
				area[2] = mem1->vaddr;
				area[3] = area[2] + mem1->sbrk_vsize - 1;
				return 0; /* sccsess */
			}
		}
	}while(name_list_next(&info) != -1);
	return -2; /* na match */
}


/*
 * return value
 *    0:  process is already dead
 *    1:  process is still alive
 */
int is_proc_alive(int userproc)
{
	NAME_INFO_LIST info;

	if (name_list_first(&info) == -1)
		return 0;
	do {
		if (info.name == userproc)
			return 1;
	} while (name_list_next(&info) == 0);


	return 0;
}

/* EOF */
