//	2000/10/14 Ogasawara Hiroyuki


#define		VGA_140DPI_APL

#include	<zheaders.h>
#include	"console.h"
#include	"zxconsole.h"

void
zxconsole_write( char *ptr, unsigned int len )
{
	for(; len-- ; ConsoleChar( Cp, *ptr++ ) );
	ConsoleFlush( Cp );
}

void
zxconsole_putchar( unsigned char ch )
{
	ConsoleChar( Cp, ch );
	ConsoleFlush( Cp );
}

void
zxconsole_putstr( char *ptr )
{
	for(; *ptr ; ConsoleChar( Cp, *ptr++ ) );
	ConsoleFlush( Cp );
}


void
zxconsole_write_t( char *ptr, unsigned int len )
{
	for(; len-- ;){
		if( *ptr == '\n' ){
			ConsoleChar( Cp, '\r' );
		}
		ConsoleChar( Cp, *ptr++ );
	}
	ConsoleFlush( Cp );
}

void
zxconsole_putstr_t( char *ptr )
{
	for(; *ptr ;){
		if( *ptr == '\n' ){
			ConsoleChar( Cp, '\r' );
		}
		ConsoleChar( Cp, *ptr++ );
	}
	ConsoleFlush( Cp );
}



void
zxconsole_init( void )
{
	WIN_WORK_EXT	contentsWindowExt;
	WINDOWHD	wh;
	int		isVGA= FALSE;

	UPOINT		ScreenSize;
	DPI		_DPI;
	GetScreenSizeAndDPI( &ScreenSize, &_DPI );
	if( ScreenSize.x >= 640 ){
		isVGA= TRUE;
	}

	contentsWindowExt.userID= APL_WIN;
	contentsWindowExt.CrLocPoint.x= 0;
	contentsWindowExt.CrLocPoint.y= 0;
	if( isVGA ){
		contentsWindowExt.CrSize.x= (640<<2)-1;
		contentsWindowExt.CrSize.y= (304<<2)-1;
		contentsWindowExt.ScreenType= 1;//VGA_SCREEN;
		contentsWindowExt.WinDPI= DPI_140;
	}else{
		contentsWindowExt.CrSize.x= (320<<2)-1;
		contentsWindowExt.CrSize.y= (152<<2)-1;
		contentsWindowExt.ScreenType= 0;//QVGA_SCREEN;
		contentsWindowExt.WinDPI= DPI_070;
	}
	contentsWindowExt.WinType= WN_TRANSPARENT;
	contentsWindowExt.DestWinNo= FrontWindow();
	contentsWindowExt.PileMode= contentsWindowExt.DestWinNo ? OVER : TOP;
	contentsWindowExt.OpenPosition= CENTER;
	contentsWindowExt.AutoAdjMode= NONE;
	SetColorV( &contentsWindowExt.Color, WHITE );
	contentsWindowExt.WinPointSize= 4;
	contentsWindowExt.WinRsvd1= 0;
	contentsWindowExt.WinRsvd2= 0;
	contentsWindowExt.WinRsvd3= 0;
	wh= OpenWindowExt( &contentsWindowExt );

	ConsoleInit( Cp, wh );
	if( isVGA ){
		extern void __BgLoad( char* );
		__BgLoad( "F1:ZLNXBG00.ZIT" );
		//ConsoleSetScreen( Cp, 80, 19, 6, 0, 0 );
		ConsoleSetScreen( Cp, 80, 24, 4, 80, 8 );
	}else{
		ConsoleSetScreen( Cp, 80, 15, 3, 0, 0 );
		//ConsoleSetScreen( Cp, 53, 12, 4, 0, 0 );
	}
	ConsoleCls( Cp );
	ConsoleSet( Cp );

}


void
zxconsole_quit( void )
{
	//nop
}

